package com.io.yutian.aulib.list;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PageList<T> {
	
	private List<T> list;
	private Map<Integer, List<T>> map = new HashMap<>();
	private int amount;
	
	public PageList(List<T> list, int amount) {
		this.list = list;
		this.amount = amount;
		if (list == null) {
			return;
		}
		if (list.size() <= amount) {
			List<T> newList = new ArrayList<T>();
			list.forEach(o-> newList.add(o));
			map.put(1, newList);
		} else {
			int x = 0;
			int c = list.size() / amount;
			for (int j = 0; j <= c;j++) {
				int min = j * amount;
				int max = (j+1) *  amount;
				List<T> newList = new ArrayList<T>();
				for (int k = min; k < max; k++) {
					if (k >= list.size()) {
						break;
					}
					newList.add(list.get(k));
				}
				map.put(j+1, newList);
			}
		}
	}
	
	public int size() {
		return map.size();
	}
	
	public List<T> getList(int page) {
		if (page <= 0) {
			page = 1;
		}
		return map.get(page);
	}
	
}
