package com.io.yutian.aulib.util;

import org.bukkit.Material;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import java.util.function.Predicate;

public class PlayerInventoryUtil {

    public static void giveItemStack(Player player, ItemStack itemStack) {
        if (PlayerInventoryUtil.hasFreeSlot(player)) {
            player.getInventory().addItem(itemStack);
        } else {
            Item item = player.getLocation().getWorld().dropItem(player.getLocation(), itemStack);
            item.setOwner(player.getUniqueId());
            item.setThrower(player.getUniqueId());
            item.setPickupDelay(20);
        }
    }

    public static boolean hasItemStack(Player player, Predicate<ItemStack> predicate) {
        return hasItemStack(player, predicate, 1);
    }

    public static boolean hasItemStack(Player player, Predicate<ItemStack> predicate, int amount) {
        int index = -1;
        int a = 0;
        while (index < 35) {
            index++;
            ItemStack i = player.getInventory().getItem(index);
            if (i == null) {
                continue;
            }
            if (predicate.test(i)) {
                a += i.getAmount();
            }
        }
        return a >= amount;
    }

    public static void takeItemStack(Player player, Predicate<ItemStack> predicate) {
        takeItemStack(player, predicate, 1);
    }

    public static void takeItemStack(Player player, Predicate<ItemStack> predicate, int amount) {
        int index = -1;
        int a = amount;
        while (index < 35) {
            if (a <= 0) {
                break;
            }
            index++;
            ItemStack i = player.getInventory().getItem(index);
            if (i == null) {
                continue;
            }
            if (predicate.test(i)) {
                int k = i.getAmount();
                if (k < a) {
                    i.setType(Material.AIR);
                } else {
                    int l = k - a;
                    i.setAmount(l);
                }
                a -= k;
            }
        }
    }

    public static boolean hasFreeSlot(Player player) {
        return getFreeSize(player) > 0;
    }

    public static int getFreeSize(Player player) {
        int index = -1;
        int freesize = 0;
        while (index < 35) {
            index++;
            ItemStack i = player.getInventory().getItem(index);
            if (i == null) {
                freesize++;
                continue;
            }
            if (i.getType().equals(Material.AIR)) {
                freesize++;
            }
        }
        return freesize;
    }

}
